glibmm: Gio::Icon Class Reference

glibmm 2.66.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Icon Class Reference

This is a very minimal interface for icons. More...

`#include <giomm/icon.h>`

Inheritance diagram for Gio::Icon:
[legend]

## Public Member Functions
| Icon (Icon&& src) noexcept
Icon& | operator= (Icon&& src) noexcept
| ~Icon () noexcept override
GIcon* | gobj ()
| Provides access to the underlying C GObject. More...
const GIcon* | gobj () const
| Provides access to the underlying C GObject. More...
guint | hash () const
| Gets a hash for an icon. More...
std::string | to_string () const
| Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage. More...
bool | equal (const Glib::RefPtr< Icon >& other) const
Glib::VariantBase | serialize () const
| Serializes a Icon into a Variant. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Icon > | create (const std::string& str)
| Generate an Icon instance from str. More...
static Glib::RefPtr< Icon > | deserialize (const Glib::VariantBase& value)
| Deserializes a Icon previously serialized using g_icon_serialize(). More...

## Protected Member Functions
| Icon ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Icon > | wrap (GIcon* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

This is a very minimal interface for icons.

It provides functions for checking the equality of two icons, hashing of icons and serializing an icon to and from strings and Variants.

Gio::Icon does not provide the actual pixmap for the icon as this is out of GIO's scope. However implementations of Icon may contain the name of an icon (see ThemedIcon), or the path to an icon (see LoadableIcon).

To obtain a hash of an Icon instance, see hash().

To check if two Icon instances are equal, see equal().

For serializing an Icon, use serialize() and deserialize().

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ Icon() [1/2]

Gio::Icon::Icon | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Icon() [2/2]

Gio::Icon::Icon | ( | Icon&& | src | ) |
| noexcept

## ◆ ~Icon()

Gio::Icon::~Icon | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gio::Icon::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ create()

static Glib::RefPtr<Icon> Gio::Icon::create | ( | const std::string & | str | ) |
| static

Generate an Icon instance from str.

This function can fail if str is not valid. See to_string() for discussion.

If your application or library provides one or more Icon implementations, you need to ensure that each GType is registered with the type system prior to calling create().

Since glibmm 2.20:

Parameters

  str | A string obtained via to_string().

Returns
  An object implementing the Icon interface, or throws an exception.

Exceptions

  Gio::Error |

## ◆ deserialize()

static Glib::RefPtr<Icon> Gio::Icon::deserialize | ( | const Glib::VariantBase& | value | ) |
| static

Deserializes a Icon previously serialized using g_icon_serialize().

Since glibmm 2.48:

Parameters

  value | A Variant created with g_icon_serialize().

Returns
  A Icon, or `nullptr` when deserialization fails.

## ◆ equal()

bool Gio::Icon::equal | ( | const Glib::RefPtr< Icon >& | other | ) | const

## ◆ get_type()

static GType Gio::Icon::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GIcon* Gio::Icon::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GIcon* Gio::Icon::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ hash()

guint Gio::Icon::hash | ( |  | ) | const

Gets a hash for an icon.

Virtual: hash

Returns
  A `unsigned int` containing a hash for the icon, suitable for use in a HashTable or similar data structure.

## ◆ operator=()

Icon& Gio::Icon::operator= | ( | Icon&& | src | ) |
| noexcept

## ◆ serialize()

Glib::VariantBase Gio::Icon::serialize | ( |  | ) | const

Serializes a Icon into a Variant.

An equivalent Icon can be retrieved back by calling g_icon_deserialize() on the returned value. As serialization will avoid using raw icon data when possible, it only makes sense to transfer the Variant between processes on the same machine, (as opposed to over the network), and within the same file system namespace.

Since glibmm 2.48:

Returns
  A Variant, or `nullptr` when serialization fails. The Variant will not be floating.

## ◆ to_string()

std::string Gio::Icon::to_string | ( |  | ) | const

Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage.

Use g_icon_new_for_string() to get icon back from the returned string.

The encoding of the returned string is proprietary to Icon except in the following two cases

- If icon is a FileIcon, the returned string is a native path (such as `/path/to/my icon.png`) without escaping if the File for icon is a native file. If the file is not native, the returned string is the result of g_file_get_uri() (such as `sftp://path/to/my%20icon.png`).
- If icon is a ThemedIcon with exactly one name and no fallbacks, the encoding is simply the name (such as `network-server`).

Virtual: to_tokens

Since glibmm 2.20:

Returns
  An allocated NUL-terminated UTF8 string or `nullptr` if icon can't be serialized.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::Icon > wrap | ( | GIcon * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.